<?php
if (stristr(htmlentities($_SERVER['PHP_SELF']), "cache-main.php")) {
    Header("Location: ../../index.php");
    die();
}
/************************************************************************/
/* PHP-NUKE: Web Portal System                                          */
/* ===========================                                          */
/*                                                                      */
/* Copyright (c) 2006 by Francisco Burzi                                */
/* http://phpnuke.org                                                   */
/*                                                                      */
/* PHP-Nuke Cache 2.1.0 for PHP-Nuke                                    */
/* Copyright (c) 2006 by Stephen Bishop (perfect-games), (dadaBIT)      */
/* http://dadanuke.org                                                  */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/

/*
  jpcache
  Copyright 2001 - 2003 Jean-Pierre Deckers <jp@jpcache.com>

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*

  Credits:
  Based upon and inspired by:
  phpCache        <nathan@0x00.org> (http://www.0x00.org/phpCache)
  gzdoc.php       <catoc@163.net> and <jlim@natsoft.com.my> 
  jr-cache.php    <jr-jrcache@quo.to>
  More info on http://www.jpcache.com/

 */
 
require_once ("mainfile.php");
/* Take a wild guess... */
    function cache_debug($s) 
    {
        static $cache_debugline;

        if ($GLOBALS["CACHE_DEBUG"]) 
        {
            $cache_debugline++;
            header("X-CacheDebug-$cache_debugline: $s");
        }
    }
    
    /* cache_key()
     *
     * Returns a hashvalue for the current. Maybe md5 is too heavy, 
     * so you can implement your own hashing-function. 
     */
    function cache_key()
    {
            if ($GLOBALS["CACHE_CLEANKEYS"])
            {
                $key = eregi_replace("[^A-Z,0-9,=]", "_", cache_scriptkey());
                $key .= ".".eregi_replace("[^A-Z,0-9,=]", "_", cache_varkey());
                if (strlen($key) > 255)
                {
                    // Too large, fallback to md5!
                    $key = md5(cache_scriptkey().cache_varkey());
                }
            }
            else
            {
                $key = md5(cache_scriptkey().cache_varkey());
            }
            cache_debug("Cachekey is set to $key");
            return $key;
    }

    /* cache_varkey()
     * 
     * Returns a serialized version of POST & GET vars
     * If you want to take cookies into account in the varkey too, 
     * add them inhere.
     */
    function cache_varkey() 
    {
        $varkey = "";
        if ($GLOBALS["CACHE_POST"])
        {
            $varkey = "POST=".serialize($_POST); 
        }
        $varkey .= "GET=".serialize($_GET);
        cache_debug("Cache varkey is set to $varkey");
        return $varkey;
    }

    /* cache_scriptkey()
     *
     * Returns the script-identifier for the request
     */
    function cache_scriptkey()
    {
        // These should be available, unless running commandline
        if ($GLOBALS["CACHE_IGNORE_DOMAIN"])
        {
            $name=$_SERVER["PHP_SELF"];
        } 
        else 
        {
            $name=$_SERVER["SCRIPT_URI"];
        }

        // Commandline mode will also fail this one, I'm afraid, as there is no
        // way to determine the scriptname
        if ($name=="")
        {
            $name="http://".$_SERVER["SERVER_NAME"].$_SERVER["SCRIPT_NAME"];
        }
        
        cache_debug("Cache scriptkey is set to $name");        
        return $name;
    }


    /* cache_check()
     *
     */
    function cache_check() 
    {
        if (!$GLOBALS["CACHE_ON"]) 
        {
            cache_debug("Cache has been disabled!");
            return false;
        }
        
        // We need to set this global, as ob_start only calls the given method
        // with no parameters.
        $GLOBALS["cache_key"] = cache_key();
        
        // Can we read the cached data for this key ?
        if (cache_restore())
        {
            cache_debug("Cachedata for ".$GLOBALS["cache_key"]." found, data restored");    
            return true;
        } 
        else 
        {
            // No cache data (yet) or unable to read
            cache_debug("No (valid) cachedata for ".$GLOBALS["cache_key"]);
            return false;
        }
    }
    
    /* cache_encoding()
     *
     * Are we capable of receiving gzipped data ?
     * Returns the encoding that is accepted. Maybe additional check for Mac ?
     */
    function cache_encoding()
    { 
        if (headers_sent() || connection_aborted())
        { 
            return false; 
        } 
        if (strpos($_SERVER["HTTP_ACCEPT_ENCODING"],'x-gzip') !== false)
        {
            return "x-gzip";
        }
        if (strpos($_SERVER["HTTP_ACCEPT_ENCODING"],'gzip') !== false)
        {
            return "gzip";
        }
        return false; 
    }

    /* cache_init()
     *
     * Checks some global variables and might decide to disable caching
     */
    function cache_init()
    {
        // Override default CACHE_TIME ?
        if (isset($GLOBALS["cachetimeout"]))
        {
            $GLOBALS["CACHE_TIME"]=$GLOBALS["cachetimeout"];
        }
        
        // Force gzip off if gzcompress does not exist
        if (!function_exists('gzcompress')) 
        {
        	$GLOBALS["CACHE_USE_GZIP"]  = 0;
        }

        // Force cache off when POST occured when you don't want it cached
        if (!$GLOBALS["CACHE_POST"] && (count($_POST) > 0)) 
        {
            $GLOBALS["CACHE_ON"] = 0;
            $GLOBALS["CACHE_TIME"] = -1;
        }
        
        // A cachetimeout of -1 disables writing, only ETag and content encoding
        if ($GLOBALS["CACHE_TIME"] == -1)
        {
            $GLOBALS["CACHE_ON"] = 0;
        }
        
        // Output header to recognize version
        header("X-Cache: cache v".$GLOBALS["CACHE_VERSION"].
                " - ".$GLOBALS["CACHE_TYPE"]);
    }

    /* cache_gc()
     *
     * Checks if garbagecollection is needed.
     */
    function cache_gc()
    {
        // Should we garbage collect ?
        if ($GLOBALS["CACHE_GC"]>0) 
        {
            mt_srand(time(NULL));
            $precision=100000;
            // Garbagecollection probability
            if (((mt_rand()%$precision)/$precision) <=
                ($GLOBALS["CACHE_GC"]/100)) 
            {
                cache_debug("Garbage Collection Hit!");
                cache_do_gc();
            }
        }
    }

    /* cache_start()
     *
     * Sets the handler for callback
     */
    function cache_start()
    {
        // Initialize cache
        cache_init();

        // Handle type-specific additional code if required
        cache_do_start();
  
        // Check cache
        if (cache_check())
        {
            // Cache is valid and restored: flush it!
            print cache_flush($GLOBALS["cachedata_gzdata"], 
                                $GLOBALS["cachedata_datasize"], 
                                $GLOBALS["cachedata_datacrc"]);
            // Handle type-specific additional code if required
            cache_do_end();
            exit;
        }
        else
        {
            // if we came here, cache is invalid: go generate page 
            // and wait for CacheEnd() which will be called automagically
            
            // Check garbagecollection
            cache_gc();
            
            // Go generate page and wait for callback
            ob_start("cache_end");
            ob_implicit_flush(0);
        }
    }

    /* cache_end()
     *
     * This one is called by the callback-funtion of the ob_start. 
     */
    function cache_end($contents)
    {
        cache_debug("Callback happened");
        
        $datasize = strlen($contents);
        $datacrc = crc32($contents);
        
        if ($GLOBALS["CACHE_USE_GZIP"]) 
        {
            $gzdata = gzcompress($contents, $GLOBALS["CACHE_GZIP_LEVEL"]);
        } 
        else 
        {
            $gzdata = $contents;
        }
        
        // If the connection was aborted, do not write the cache.
        // We don't know if the data we have is valid, as the user
        // has interupted the generation of the page.
        // Also check if cache is not disabled
        if ((!connection_aborted()) && 
             $GLOBALS["CACHE_ON"] && 
            ($GLOBALS["CACHE_TIME"] >= 0))
        {
            cache_debug("Writing cached data to storage");
            // write the cache with the current data
            cache_write($gzdata, $datasize, $datacrc);
        }
        
        // Handle type-specific additional code if required
        cache_do_end();

        // Return flushed data
        return cache_flush($gzdata, $datasize, $datacrc);
    }

    /* cache_flush()
     *
     * Responsible for final flushing everything.
     * Sets ETag-headers and returns "Not modified" when possible
     *
     * When ETag doesn't match (or is invalid), it is tried to send
     * the gzipped data. If that is also not possible, we sadly have to
     * uncompress (assuming CACHE_USE_GZIP is on)
     */
    function cache_flush($gzdata, $datasize, $datacrc)
    {       
        // First check if we can send last-modified
        $myETag = "\"d-$datacrc.$datasize\"";
        header("ETag: $myETag");
        $foundETag = isset($_SERVER["HTTP_IF_NONE_MATCH"]) ? stripslashes($_SERVER["HTTP_IF_NONE_MATCH"]) : "";
        $ret = NULL;
        
        if (strstr($foundETag, $myETag))
        {
            // Not modified!
            if(stristr($_SERVER["SERVER_SOFTWARE"], "microsoft"))
    	    {
    	        // IIS has already sent a HTTP/1.1 200 by this stage for
    	        // some strange reason
                header("Status: 304 Not Modified");
            } 
            else 
            {
                header("HTTP/1.0 304");
            }
        }
        else
        {
            // Are we gzipping ?
            if ($GLOBALS["CACHE_USE_GZIP"]) 
            {
                $ENCODING = cache_encoding(); 
                if ($ENCODING) 
                { 
                    // compressed output: set header. Need to modify, as
                    // in some versions, the gzipped content is not what
                    // your browser expects.
                    header("Content-Encoding: $ENCODING");
                    $ret =  "\x1f\x8b\x08\x00\x00\x00\x00\x00";
                    $ret .= substr($gzdata, 0, strlen($gzdata) - 4);
                    $ret .= pack('V',$datacrc);
                    $ret .= pack('V',$datasize);
                } 
                else 
                {
                    // Darn, we need to uncompress :(
                    $ret = gzuncompress($gzdata);
                }
            } 
            else 
            {
                // So content isn't gzipped either
                $ret=$gzdata;
            }
        }
        return $ret;
    }
    
?>