<?php
if (stristr(htmlentities($_SERVER['PHP_SELF']), "mysql.php")) {
    Header("Location: ../../../index.php");
    die();
}
/************************************************************************/
/* PHP-NUKE: Web Portal System                                          */
/* ===========================                                          */
/*                                                                      */
/* Copyright (c) 2006 by Francisco Burzi                                */
/* http://phpnuke.org                                                   */
/*                                                                      */
/* PHP-Nuke Cache 2.1.0 for PHP-Nuke                                    */
/* Copyright (c) 2006 by Stephen Bishop (perfect-games), (dadaBIT)      */
/* http://dadanuke.org                                                  */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/

/*
  jpcache
  Copyright 2001 - 2003 Jean-Pierre Deckers <jp@jpcache.com>

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*

  Credits:
  Based upon and inspired by:
  phpCache        <nathan@0x00.org> (http://www.0x00.org/phpCache)
  gzdoc.php       <catoc@163.net> and <jlim@natsoft.com.my> 
  jr-cache.php    <jr-jrcache@quo.to>
  More info on http://www.jpcache.com/

 */
 	 
    function cache_db_connect()
    {
        $GLOBALS["sql_link"] = @mysql_connect($GLOBALS["CACHE_DB_HOST"], 
                                              $GLOBALS["CACHE_DB_USERNAME"],
                                              $GLOBALS["CACHE_DB_PASSWORD"]);
    }
    
    /* cache_db_disconnect()
     *
     * Closes connection to the database
     */
    function cache_db_disconnect()
    {
        mysql_close($GLOBALS["sql_link"]);
    }
    
    /* cache_db_query($query)
     *
     * Executes a given query
     */    
    function cache_db_query($query)
    {
        // cache_debug("Executing SQL-query $query");
        $ret = @mysql_db_query($GLOBALS["CACHE_DB_DATABASE"],
                               $query, 
                               $GLOBALS["sql_link"]);
        return $ret;
    }
    
    /* cache_restore()
     *
     * Will try to restore the cachedata from the db.
     */
    function cache_restore()
    {
        $res = cache_db_query("select GZDATA, DATASIZE, DATACRC from ".
                                    $GLOBALS["CACHE_DB_TABLE"].
                                " where CACHEKEY='".
                                    addslashes($GLOBALS["cache_key"]).
                                "' and (CACHEEXPIRATION>".
                                    time().
                                " or CACHEEXPIRATION=0)"
                               );
                                
        if ($res && mysql_num_rows($res))
        {
            if ($row = mysql_fetch_array($res))
            {
                // restore data into global scope from found row
                $GLOBALS["cachedata_gzdata"]   = $row["GZDATA"];
                $GLOBALS["cachedata_datasize"] = $row["DATASIZE"];
                $GLOBALS["cachedata_datacrc"]  = $row["DATACRC"];
                return true;
            }
        }
        return false;
    }

    /* cache_write()
     *
     * Will (try to) write out the cachedata to the db
     */
    function cache_write($gzdata, $datasize, $datacrc) 
    {
        $dbtable = $GLOBALS["CACHE_DB_TABLE"];
        
        // XXX: Later on, maybe implement locking mechanism in here.
        
        // Check if it already exists
        $res = cache_db_query("select CACHEEXPIRATION from $dbtable".
                                " where CACHEKEY='".
                                    addslashes($GLOBALS["cache_key"]).
                                "'"
                               );
        
        
        if (!$res || mysql_num_rows($res) < 1) 
        {
            // Key not found, so insert
            $res = cache_db_query("insert into $dbtable".
                                    " (CACHEKEY, CACHEEXPIRATION, GZDATA,".
                                    " DATASIZE, DATACRC) values ('".
                                        addslashes($GLOBALS["cache_key"]).
                                    "',".
                                        (($GLOBALS["CACHE_TIME"] != 0) ? 
                                        (time()+$GLOBALS["CACHE_TIME"]) : 0).
                                    ",'".
                                        addslashes($gzdata).
                                    "', $datasize, $datacrc)"
                                   );
            // This fails with unique-key violation when another thread has just
            // inserted the same key. Just continue, as the result is (almost) 
            // the same.
        }
        else
        {
            // Key found, so update
            $res = cache_db_query("update $dbtable set CACHEEXPIRATION=".
                                        (($GLOBALS["CACHE_TIME"] != 0) ?
                                        (time()+$GLOBALS["CACHE_TIME"]) : 0).
                                    ", GZDATA='".
                                        addslashes($gzdata).
                                    "', DATASIZE=$datasize, DATACRC=$datacrc where".
                                    " CACHEKEY='".
                                        addslashes($GLOBALS["cache_key"]).
                                    "'"
                                   );
            // This might be an update too much, but it shouldn't matter
        }
    }
   
    /* cache_do_gc()
     *
     * Performs the actual garbagecollection
     */
    function cache_do_gc()
    {
        cache_db_query("delete from ".
                            $GLOBALS["CACHE_DB_TABLE"].
                         " where CACHEEXPIRATION<=".
                            time().
                         " and CACHEEXPIRATION!=0"
                        );
                        
        // Are we allowed to do an optimize table-call?
        // As noted, first check if this works on your mysql-installation!
        if ($GLOBALS["CACHE_OPTIMIZE"])
        {
            cache_db_query("OPTIMIZE TABLE ".$GLOBALS["CACHE_DB_TABLE"]);                       
        }
    }

    
    /* cache_do_start()
     *
     * Additional code that is executed before main cache-code kicks in.
     */
    function cache_do_start()
    {  
        // Connect to db
        cache_db_connect();
    }

    /* cache_do_end()
     *
     * Additional code that is executed after caching has been performed,
     * but just before output is returned. No new output can be added!
     */
    function cache_do_end()
    {
        // Disconnect from db
        cache_db_disconnect();
    }
    
?>